#include<connectdlg/connectdlg.h>

enum{
    ID_CONNECT = wxID_HIGHEST + 1,
    ID_CLOSE
};


Connect_dlg::Connect_dlg(wxWindow *parent)
: wxDialog(parent, -1, _("Connect"), wxDefaultPosition, wxSize(300, 200))
{
    wxFlexGridSizer *sizer = new wxFlexGridSizer(2, 6, 5);
    sizer->AddGrowableCol(1);

    wxStaticText *label = new wxStaticText(this, -1, _("Host :"));
    sizer->Add(label, 0, wxALIGN_CENTER_VERTICAL|wxALIGN_RIGHT);
    this->host_ = new wxTextCtrl(this, -1, _("localhost"));
    sizer->Add(this->host_, 0, wxEXPAND|wxALIGN_CENTER_VERTICAL);
    label = new wxStaticText(this, -1, _("Port :"));
    sizer->Add(label, 0, wxALIGN_CENTER_VERTICAL|wxALIGN_RIGHT);
    this->port_ = new wxSpinCtrl(this, -1, wxT("5432"), wxDefaultPosition,
                                 wxDefaultSize, wxSP_ARROW_KEYS, 0, 65535);
    sizer->Add(this->port_);
    label = new wxStaticText(this, -1, _("Database :"));
    sizer->Add(label, 0, wxALIGN_CENTER_VERTICAL|wxALIGN_RIGHT);
    this->dbname_ = new wxTextCtrl(this, -1);
    sizer->Add(this->dbname_, 0, wxEXPAND|wxALIGN_CENTER_VERTICAL);
    label = new wxStaticText(this, -1, _("User :"));
    sizer->Add(label, 0, wxALIGN_CENTER_VERTICAL|wxALIGN_RIGHT);
    this->user_ = new wxTextCtrl(this, -1);
    sizer->Add(this->user_, 0, wxEXPAND|wxALIGN_CENTER_VERTICAL);
    label = new wxStaticText(this, -1, _("Password :"));
    sizer->Add(label, 0, wxALIGN_CENTER_VERTICAL|wxALIGN_RIGHT);
    this->password_ = new wxTextCtrl(this, -1, wxEmptyString, wxDefaultPosition,
                                     wxDefaultSize, wxTE_PASSWORD);
    sizer->Add(this->password_, 0, wxEXPAND|wxALIGN_CENTER_VERTICAL);
    wxButton *button = new wxButton(this, ID_CONNECT, _("Connect"));
    sizer->Add(button);
    button = new wxButton(this, ID_CLOSE, _("Close"));
    sizer->Add(button);

    this->SetSizer(sizer);
}


void
Connect_dlg::connect_click(wxCommandEvent&){
    if(this->host_->GetValue() == wxEmptyString){
        this->host_->SetFocus();
        return;
    }
    if(this->dbname_->GetValue() == wxEmptyString){
        this->dbname_->SetFocus();
        return;
    }
    if(this->user_->GetValue() == wxEmptyString){
        this->user_->SetFocus();
        return;
    }
    if(this->password_->GetValue() == wxEmptyString){
        this->password_->SetFocus();
        return;
    }
    this->EndModal(0);
}


void
Connect_dlg::close_click(wxCommandEvent&){
    this->EndModal(1);
}


wxString
Connect_dlg::conninfo(){
    wxString res;
    res.Printf(wxT("host=%s port=%d dbname=%s user=%s password=%s"),
               this->host_->GetValue().c_str(), this->port_->GetValue(),
               this->dbname_->GetValue().c_str(), this->user_->GetValue().c_str(),
               this->password_->GetValue().c_str());
    return res;
}


BEGIN_EVENT_TABLE(Connect_dlg, wxDialog)
    EVT_BUTTON(ID_CONNECT, Connect_dlg::connect_click)
    EVT_BUTTON(ID_CLOSE, Connect_dlg::close_click)
END_EVENT_TABLE()
