/* binding_list.cpp - helper functions for binding wxItemContainer to
    wxPg::List_binding

    Copyright (C) 2008, 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/

#include<wxPg/binding/binding_list.h>
#include<wx/bmpcbox.h>
#include<wx/choice.h>
#include<wx/combobox.h>
#include<wx/htmllbox.h>
#include<wx/listbox.h>
#include<wx/radiobox.h>


wxPg::wxWindow_list_updater::wxWindow_list_updater(wxWindow *win)
: win_(win)
{}



wxPg::wxItemContainer_list_updater::wxItemContainer_list_updater(
        wxBitmapComboBox *combo, const wxString &field)
: wxPg::wxWindow_list_updater(combo), field_(field)
{}


wxPg::wxItemContainer_list_updater::wxItemContainer_list_updater(
        wxChoice *list, const wxString &field)
: wxPg::wxWindow_list_updater(list), field_(field)
{}


wxPg::wxItemContainer_list_updater::wxItemContainer_list_updater(
        wxComboBox *combo, const wxString &field)
: wxPg::wxWindow_list_updater(combo), field_(field)
{}


wxPg::wxItemContainer_list_updater::wxItemContainer_list_updater(
        wxSimpleHtmlListBox *list, const wxString &field)
: wxPg::wxWindow_list_updater(list), field_(field)
{}


wxPg::wxItemContainer_list_updater::wxItemContainer_list_updater(
        wxListBox *list, const wxString &field)
: wxPg::wxWindow_list_updater(list), field_(field)
{}


wxPg::wxItemContainer_list_updater::wxItemContainer_list_updater(
        wxOwnerDrawnComboBox *list, const wxString &field)
: wxPg::wxWindow_list_updater(list), field_(field)
{}


wxPg::wxItemContainer_list_updater::wxItemContainer_list_updater(
        wxRadioBox *radio_box, const wxString &field)
: wxPg::wxWindow_list_updater(radio_box), field_(field)
{}


void
wxPg::wxItemContainer_list_updater::begin_update(Result_data_provider *data){
    this->tmp_values_.Alloc(data->rows());
}


void
wxPg::wxItemContainer_list_updater::update_row(Result_data_provider *data){
    this->tmp_values_.Add(data->get_str(this->field()));
}


void
wxPg::wxItemContainer_list_updater::end_update(){
    wxItemContainer *cont = dynamic_cast<wxItemContainer*>(this->window());
    if(cont){
        cont->Clear();
        cont->Append(this->tmp_values_);
    }
    this->tmp_values_.Clear();
}


void
wxPg::wxItemContainer_list_updater::operator()(Result_data_provider *data){}
