/* grid.cpp - implementation of class wxPg::Grid - grid widget.

    Copyright (C) 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/


#include<wxPg/widgets/controls/grid.h>


wxPg::Grid::Grid()
: wxGrid()
{}


wxPg::Grid::Grid(wxWindow *parent, wxWindowID id, const wxPoint &pos,
                 const wxSize &size, long style, const wxString &name)
: wxGrid(parent, id, pos, size, style, name)
{}


wxPg::Grid::~Grid(){
    this->SetTable(NULL);
}


bool
wxPg::Grid::open(const wxString &sql){
    if(!this->database())
        return false;
    Grid_table *table = static_cast<Grid_table*>(this->GetTable());
    bool new_table = !table;
    if(new_table)
        table = &this->table_;
    if(!table->query().open(sql))
        return false;
    if(!table->query().fetch(0, wxPg::Query::FM_LAST))
        return false;
    table->use_midle_fetch(false);
    if(new_table)
        this->SetTable(table);
    else{
        this->SetTable(NULL);
        this->SetTable(table);
    }
    this->ForceRefresh();
    table->use_midle_fetch(true);
    return true;
}

