/* test_logger.h - test_logger class for test programs.

    Copyright (C) 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __TEST_LOGGER_H
#define __TEST_LOGGER_H

#include<fstream>

class
test_logger{
public:
    test_logger();

    ~test_logger();

    void
    log_success(const char *name);

    void
    log_error(const char *name, const char *detail);

    void
    log_check_point(const char *name);

    void
    output_summary();
private:
    std::ofstream
    log_file_;

    unsigned
    tests_, pass_;
};

extern test_logger
logger;

#endif
