/* testdb.cpp - Database class for test programs.

    Copyright (C) 2009 Aurimas Černius

    This file is part of wxPostgres.

    wxPostgres is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wxPostgres is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with wxPostgres.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "testdb.h"
#include "coninfo.h"
#include<iostream>

Database
db;

void
Database::sql_monitor(const wxString &sql){
    this->sql_mon_ += wxT("\n");
    this->sql_mon_ += sql;
}


wxString
Database::clean_sql_mon(){
    wxString s = this->sql_mon_;
    this->sql_mon_ = wxT("");
    return s;
}


bool
db_connect(){
    db.connection_info(wxString::From8BitData(CONINFO));
    if(!db.connect()){
        std::cerr << "Failed to connect: " << db.last_err().char_str();
        return false;
    }

    return true;
}
